<?php
class TabulizerModifySethreftarget {
    function modify(&$rows, $args = null) {
        if (empty($rows)) return;
    
        $num_of_rows = count($rows);
        $num_of_columns = count($rows[1]);        
        
        $target = (!empty($args))?$args:"_blank";
        
        $dom = new DomDocument();
        
        for ($i=1;$i<=$num_of_rows;$i++) {            
            for ($j=1;$j<=$num_of_columns;$j++) {        
                if (preg_match_all('/(<a.*?href=.+?<\/a>)/i', $rows[$i][$j], $matches)) {    
                  $replacement_from = array();
                  $replacement_to = array();   
                  $links = $matches[0];
                  foreach ($links as $link) {       
                      $replace_from_str = $link;
                      $replace_to_str = null;
                      $dom->loadHTML('<meta http-equiv="content-type" content="text/html; charset=utf-8">'.$link);
                      $anchors = $dom->getElementsByTagName('a');
                      foreach ($anchors as $a) {
                        $a->setAttribute("target", $target);
                      }                  
                      $link_with_tags = $dom->saveHTML();   
                      if (preg_match('/(<a.*?href=.+?<\/a>)/i', $link_with_tags, $link_matches)) {  
                        $replace_to_str = $link_matches[0];
                        $replacement_from[] = $replace_from_str;
                        $replacement_to[] = $replace_to_str;
                      }   
                  }
                  $rows[$i][$j] = str_replace($replacement_from, $replacement_to, $rows[$i][$j]);   
                }                                                
            }                                   
        }        
    }
}
?>